(*
    ===========================================================================

    AboutBox

    ---------------------------------------------------------------------------

    2003/12/02  C

    ===========================================================================
*)
unit Info;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, ExtCtrls, StdCtrls;

type
  TInfoForm = class(TForm)
    AppIcon: TImage;
    Panel1: TPanel;
    Panel3: TPanel;
    lblMail: TLabel;
    lblURL: TLabel;
    Panel2: TPanel;
    Label3: TLabel;
    Label4: TLabel;
    lblExeName: TLabel;
    lblComment: TLabel;
    BitBtn1: TBitBtn;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure lblURLClick(Sender: TObject);
    procedure lblMailClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BitBtn1Click(Sender: TObject);
  private

  public

  end;

procedure   SimpleShellExecute(const FileName: string);
procedure   OpenInfoForm();

implementation

uses
    ShellApi, Main;

{$R *.dfm}

(*
    ===========================================================================
    ShellExecutebp[
    ===========================================================================
*)
procedure   SimpleShellExecute(const FileName: string);
begin
    try
        ShellExecute(Application.MainForm.Handle, nil, PChar(FileName), nil, nil, SW_SHOW);
    except
        ;
    end;
end;

(*
    ===========================================================================
    OJ
    ===========================================================================
*)
var
    InfoForm: TInfoForm;

procedure   OpenInfoForm();
begin
    MainForm.MenuAbout.Enabled := false;
    InfoForm := TInfoForm.Create(Application);
    InfoForm.Show();
end;

(*
    ===========================================================================
    tH[RXgN^
    ===========================================================================
*)
procedure TInfoForm.FormCreate(Sender: TObject);
begin
    Self.Caption := Application.Title;

    lblExeName.Caption := ExtractFileName(ParamStr(0)); 
    AppIcon.Picture.Icon := Application.Icon;
end;

(*
    ===========================================================================
    z[y[WN
    ===========================================================================
*)
procedure TInfoForm.lblURLClick(Sender: TObject);
begin
    SimpleShellExecute(lblURL.Caption);
end;

(*
    ===========================================================================
    [[N
    ===========================================================================
*)
procedure TInfoForm.lblMailClick(Sender: TObject);
begin
    SimpleShellExecute(Format('MailTo:%s?subject=from [%s] user', [lblMail.Caption, ExtractFileName(ParamStr(0))]));
end;

(*
    ===========================================================================
    ESCŏI
    ===========================================================================
*)
procedure TInfoForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if Key = VK_ESCAPE then Self.Close;
end;

(*
    ===========================================================================
    OKŏI
    ===========================================================================
*)
procedure TInfoForm.BitBtn1Click(Sender: TObject);
begin
    Self.Close;
end;

(*
    ===========================================================================
    OnClose
    ===========================================================================
*)
procedure TInfoForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    Action := caFree;
    MainForm.MenuAbout.Enabled := true;
end;

end.
