(*
    ===========================================================================

    ݒ

    ---------------------------------------------------------------------------

    2004/02/08  n

    ===========================================================================
*)

unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  ExtCtrls, StdCtrls, Buttons, IniFiles, Dialogs, Menus, ShellApi;

const
    WM_NotifyTasktray = WM_APP + 100;

type
  TMainForm = class(TForm)
    BtnOK: TBitBtn;
    BtnCancel: TBitBtn;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    EditDesktopStr: TEdit;
    EditMyComputerStr: TEdit;
    EditMyNetworkStr: TEdit;
    Image4: TImage;
    Label6: TLabel;
    EditWaitForCheck: TEdit;
    Label8: TLabel;
    EditWaitForOK: TEdit;
    Label5: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    Bevel4: TBevel;
    Image5: TImage;
    Label9: TLabel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    PopupMenu: TPopupMenu;
    MenuDbgMsg: TMenuItem;
    MenuAbout: TMenuItem;
    MenuConfig: TMenuItem;
    N2: TMenuItem;
    MenuExit: TMenuItem;
    MenuCancel: TMenuItem;
    MenuDbgMem: TMenuItem;
    BitBtn3: TBitBtn;
    Label10: TLabel;
    Label11: TLabel;
    EditWaitForClick: TEdit;
    BitBtn4: TBitBtn;
    MenuMisc: TMenuItem;
    MenuThis: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure BtnOKClick(Sender: TObject);
    procedure BtnCancelClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure MenuDbgMsgClick(Sender: TObject);
    procedure MenuConfigClick(Sender: TObject);
    procedure MenuAboutClick(Sender: TObject);
    procedure MenuExitClick(Sender: TObject);
    procedure MenuDbgMemClick(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure MenuThisClick(Sender: TObject);
  private
    FIniFile    : TIniFile;
    IsLiveTasktray: boolean;
    NotifyIcon  : TNotifyIconData;
    procedure   InitTasktray;
    procedure   FinishTasktray;
  protected
    procedure   TrayMessage(var Msg: TMsg); message WM_NotifyTasktray;  
  public
    constructor Create(AOwner: TComponent); override;
  end;

var
    MainForm: TMainForm;

implementation

{$R *.dfm}
{$R Extra.res}

uses
    ShlObj, ActiveX, ComObj, iChii, Info, ShwMsg, ShwMem;

(*
    =================================================================
    RXgN^
    -----------------------------------------------------------------
    http://www2.big.or.jp/~osamu/Delphi/Tips/key.cgi?key=16
    http://www.borland.co.jp/qanda/delphi/d0003457.html
    http://www.apionet.or.jp/~tubokura/k_tips.html
    =================================================================
*)
procedure TMainForm.FormCreate(Sender: TObject);
var
    WindowLongValue: integer;
begin
    //  ^XNgCɈړ
    Application.ShowMainForm := False;
    InitTaskTray;

    //  ݒt@CǍ
    FIniFile := TIniFile.Create(ChangeFileExt(ParamStr(0), '.ini'));
    //  tH_
    DESKTOP_STR := FIniFile.ReadString('ClickHere', 'Desktop', DESKTOP_STR);
    MYCOMPUTER_STR := FIniFile.ReadString('ClickHere', 'MyComputer', MYCOMPUTER_STR);
    MYNETWORK_STR := FIniFile.ReadString('ClickHere', 'MyNetwork', MYNETWORK_STR);
    //  ҂Ԑݒ
    WAIT_FOR_CHECK := FIniFile.ReadInteger('ClickHere', 'WaitForCheck', WAIT_FOR_CHECK);
    WAIT_FOR_OK    := FIniFile.ReadInteger('ClickHere', 'WaitForOK', WAIT_FOR_OK);
    WAIT_FOR_CLICK := FIniFile.ReadInteger('ClickHere', 'WaitForClick', WAIT_FOR_CLICK);
    //  \
    EditDesktopStr.Text    := DESKTOP_STR;
    EditMyComputerStr.Text := MYCOMPUTER_STR;
    EditMyNetworkStr.Text  := MYNETWORK_STR;
    EditWaitForCheck.Text  := IntToStr(WAIT_FOR_CHECK);
    EditWaitForOK.Text     := IntToStr(WAIT_FOR_OK);
    EditWaitForClick.Text  := IntToStr(WAIT_FOR_CLICK);

    //  l̂ݓ͂
    WindowLongValue := GetWindowLong(EditWaitForCheck.Handle,GWL_STYLE);
    WindowLongValue := WindowLongValue or ES_NUMBER;
    SetWindowLong(EditWaitForCheck.Handle, GWL_STYLE, WindowLongValue);
    SetWindowLong(EditWaitForOK.Handle   , GWL_STYLE, WindowLongValue);
    SetWindowLong(EditWaitForClick.Handle, GWL_STYLE, WindowLongValue);
    //  
    PostMessage(EditWaitForCheck.Handle, EM_LIMITTEXT, 3, 0);
    PostMessage(EditWaitForOK.Handle   , EM_LIMITTEXT, 3, 0);
    PostMessage(EditWaitForClick.Handle, EM_LIMITTEXT, 3, 0);
end;

(*
    =================================================================
    tH[fXgN^
    =================================================================
*)
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    //  tH_ۑ
    FIniFile.WriteString('ClickHere', 'Desktop', DESKTOP_STR);
    FIniFile.WriteString('ClickHere', 'MyComputer', MYCOMPUTER_STR);
    FIniFile.WriteString('ClickHere', 'MyNetwork', MYNETWORK_STR);
    //  ҂ԕۑ
    FIniFile.WriteInteger('ClickHere', 'WaitForCheck', WAIT_FOR_CHECK);
    FIniFile.WriteInteger('ClickHere', 'WaitForOK', WAIT_FOR_OK);
    FIniFile.WriteInteger('ClickHere', 'WaitForClick', WAIT_FOR_CLICK);

    FIniFile.Free;

    //  ^XNgCEo
    FinishTasktray;
end;

(*
    =================================================================
    
    =================================================================
*)
procedure TMainForm.BtnOKClick(Sender: TObject);
begin
    DESKTOP_STR    := EditDesktopStr.Text;
    MYCOMPUTER_STR := EditMyComputerStr.Text;
    MYNETWORK_STR  := EditMyNetworkStr.Text;
    WAIT_FOR_CHECK := StrToInt(EditWaitForCheck.Text);
    WAIT_FOR_OK    := StrToInt(EditWaitForOK.Text);
    WAIT_FOR_CLICK := StrToInt(EditWaitForClick.Text);

    Self.Hide();
end;

(*
    =================================================================
    LZ
    =================================================================
*)
procedure TMainForm.BtnCancelClick(Sender: TObject);
begin
    Self.Hide();
end;


(*
    ===========================================================================
    񃁃bZ[W_CAO
    ===========================================================================
*)
procedure   SimpleMessage(AMsg: string);
var
    Dialog: TForm;
    Image : TImage;
begin
    Application.NormalizeTopMosts;

    Dialog := CreateMessageDialog(AMsg, mtInformation, [mbOK]);
    try
        Image := TImage(Dialog.FindComponent('Image'));
        if (Image <> nil) then Image.Picture.Icon.Assign(Application.Icon);
        Dialog.ShowModal;
    finally
        Dialog.Free;
    end;

    Application.RestoreTopMosts;
end;

(*
    ===========================================================================
    X^[gAbvpX
    ===========================================================================
*)
function    GetStartUpPath(): string;
var
    pidlPath: PItemIDList;
    StartupPath: array[0..MAX_PATH] of Char;
begin
    //  X^[gAbvpX̎擾
    SHGetSpecialFolderLocation(Application.Handle, CSIDL_STARTUP, pidlPath);
    SHGetPathFromIDList(pidlPath, StartupPath);
    Result := StartupPath;
end;


(*
    =================================================================
    X^[gAbvɓo^
    -----------------------------------------------------------------
    http://hp.vector.co.jp/authors/VA009712/take/delphi/kabesys.htm#ishelllink
    =================================================================
*)
procedure TMainForm.BitBtn1Click(Sender: TObject);
var
    ShellLink: IShellLink;
    PersistFile: IPersistFile;
    FileName: String;
    LinkFileName: string;
    WFileName: WideString;
begin
    //  V[gJbg̐ݒ
    FileName:= ParamStr(0);
    //  V[gJbgpCOMIuWFNg쐬
    ShellLink := CreateComObject(CLSID_ShellLink) as IShellLink;
    //  V[gJbgt@CpIuWFNg
    PersistFile := ShellLink as IPersistFile;
    with ShellLink do
    begin
        //  t@ČɎw肷p[^
        SetArguments('/starup');
        //  st@C̃tpX
        SetPath(PChar(FileName));
        //  ƃtH_
        SetWorkingDirectory(PChar(ExtractFileDir(FileName)));
    end;

    //  V[gJbgt@C̍쐬
    FileName := ChangeFileExt(ExtractFilename(FileName), '.lnk');
    LinkFileName := Format('%s\%s',[GetStartUpPath(), FileName]);
    WFileName := WideString(LinkFileName);
    //  t@C쐬
    OleCheck(PersistFile.Save(PWChar(WFileName), False));

    //  I
    SimpleMessage('It would be created in <HOGEHOGE>\STARTUP\.');
end;

(*
    =================================================================
    X^[gAbvJ
    -----------------------------------------------------------------
    http://hp.vector.co.jp/authors/VA009712/take/delphi/kabesys.htm#ishelllink
    =================================================================
*)
procedure TMainForm.BitBtn2Click(Sender: TObject);
begin
    ShellExecute(Application.MainForm.Handle, nil, PChar(GetStartUpPath()), nil, nil, SW_SHOW);
end;

(*
    =================================================================
    fXNgbvɃV[gJbg
    -----------------------------------------------------------------
    http://hp.vector.co.jp/authors/VA009712/take/delphi/kabesys.htm#ishelllink
    =================================================================
*)
procedure TMainForm.BitBtn3Click(Sender: TObject);
var
    ShellLink: IShellLink;
    PersistFile: IPersistFile;
    FileName: String;
    LinkFileName: string;
    WFileName: WideString;
begin
    //  V[gJbg̐ݒ
    FileName:= ParamStr(0);
    //  V[gJbgpCOMIuWFNg쐬
    ShellLink := CreateComObject(CLSID_ShellLink) as IShellLink;
    //  V[gJbgt@CpIuWFNg
    PersistFile := ShellLink as IPersistFile;
    with ShellLink do
    begin
        //  st@C̃tpX
        SetPath(PChar(FileName));
        //  ƃtH_
        SetWorkingDirectory(PChar(ExtractFileDir(FileName)));
    end;

    //  V[gJbgt@C̍쐬
    FileName := ChangeFileExt(ExtractFilename(FileName), '.lnk');
    LinkFileName := Format('%s\%s',[GetDesktopPath(), FileName]);
    WFileName := WideString(LinkFileName);
    //  t@C쐬
    OleCheck(PersistFile.Save(PWChar(WFileName), False));

    //  I
    SimpleMessage('It would be created in DESKTOP.');
end;

(*
    =================================================================
    fXNgbv\
    -----------------------------------------------------------------
    http://homepage1.nifty.com/MADIA/vb/vb_bbs/200304_03040017.html
    http://www.elists.org/pipermail/delphi/2003-December/024919.html
    =================================================================
*)
procedure TMainForm.BitBtn4Click(Sender: TObject);
var
    Shell: OleVariant;
begin
    Shell := CreateOleObject('Shell.Application');
    Shell.MinimizeAll;
    Shell := Unassigned;
end;


(*
    ===========================================================================
    RXgN^
    ---------------------------------------------------------------------------
    http://www.borland.co.jp/qanda/delphi/d0009410.html
    ===========================================================================
*)
constructor TMainForm.Create(AOwner: TComponent);
begin
    inherited;
    IsLiveTaskTray := False;
end;

(*
    ===========================================================================
    EBhEbZ[W
    ---------------------------------------------------------------------------
    http://www.borland.co.jp/qanda/delphi/d0009410.html
    http://www.wwlnk.com/boheme/delphi/tips/tec0310.htm
    http://www.tls.org/~akiraand/tech_01.html
    ===========================================================================
*)
procedure   TMainForm.TrayMessage(var Msg: TMsg);
begin
    case Msg.wParam of
//        WM_LBUTTONDOWN,
        WM_RBUTTONDOWN:
            begin
                SetForegroundWindow(Handle);
                PopupMenu.Popup(Mouse.CursorPos.X, Mouse.CursorPos.Y);
            end;
//        WM_RBUTTONDBLCLK,
        WM_LBUTTONDBLCLK:
            begin
                SetForegroundWindow(Handle);
                MenuConfig.OnClick(MenuConfig);
            end;
    end;
end;

(*
    ===========================================================================
    ^XNgCɃZbg
    ---------------------------------------------------------------------------
    http://www.borland.co.jp/qanda/delphi/d0009410.html
    http://homepage1.nifty.com/~okapon/download/delphi/tips1.html
    ===========================================================================
*)
procedure TMainForm.InitTasktray;
var

    TempIcon: HICON;
begin
    //  Ƀ^XNgCȂXLbv
    if IsLiveTasktray then exit;
    //  \̏
    FillChar(NotifyIcon, SizeOf(NotifyIcon), #0);
    TempIcon := LoadIcon(HInstance, 'TRAYICON');
    with NotifyIcon do
    begin
        cbSize := SizeOf(TNotifyIconData);
        Wnd    := Handle;
        uID    := 1;
        uFlags := NIF_ICON or NIF_MESSAGE or NIF_TIP;
        uCallbackMessage := WM_NotifyTasktray;
        if (TempIcon <> 0) then
            hIcon  := TempIcon
        else
            hIcon  := Application.Icon.Handle
        ;
    end;
    //  `bvwvݒ
    StrPLCopy(NotifyIcon.szTip, ChangeFileExt(ExtractFileName(ParamStr(0)), ''), 64);
    //  ǉ
    Shell_NotifyIcon(NIM_ADD, @NotifyIcon);
    //  tOON
    IsLiveTasktray := True;
end;

(*
    ===========================================================================
    ^XNgC
    ---------------------------------------------------------------------------
    http://www.borland.co.jp/qanda/delphi/d0009410.html
    ===========================================================================
*)
procedure TMainForm.FinishTasktray;
begin
    //  Ƀ^XNgCɂȂȂXLbv
    if not IsLiveTasktray then exit;
    //  \̏
    with NotifyIcon do
    begin
        cbSize := SizeOf(TNotifyIconData);
        Wnd := Handle;
        uID := 1;
    end;
    //  폜
    Shell_NotifyIcon(NIM_DELETE, @NotifyIcon);
    //  tOOFF
    IsLiveTasktray := False;
end;

(*
    ===========================================================================
    j[/I
    ===========================================================================
*)
procedure TMainForm.MenuExitClick(Sender: TObject);
begin
    Self.Close;
end;

(*
    ===========================================================================
    j[/
    ===========================================================================
*)
procedure TMainForm.MenuAboutClick(Sender: TObject);
begin
    OpenInfoForm();
end;

(*
    ===========================================================================
    j[/ݒ
    ===========================================================================
*)
procedure TMainForm.MenuConfigClick(Sender: TObject);
begin
    MainForm.Show();
end;

(*
    ===========================================================================
    |bvAbvj[/fobO\1
    ===========================================================================
*)
procedure TMainForm.MenuDbgMsgClick(Sender: TObject);
begin
    OpenShwMsgForm();
end;

(*
    ===========================================================================
    |bvAbvj[/fobO\2
    ===========================================================================
*)
procedure TMainForm.MenuDbgMemClick(Sender: TObject);
begin
    OpenShwMemForm();
end;

(*
    ===========================================================================
    CXg[tH_I[v
    ===========================================================================
*)
procedure TMainForm.MenuThisClick(Sender: TObject);
begin
    SimpleShellExecute(ExtractFilePath(ParamStr(0)));
end;

end.

