unit ShwMem;

interface

uses
  Windows, SysUtils, Forms, StdCtrls, Classes, Controls, ExtCtrls;

type
  TShwMemForm = class(TForm)
    ListBox1: TListBox;
    Timer1: TTimer;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure Timer1Timer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private

  public

  end;

procedure   OpenShwMemForm();

implementation

{$R *.dfm}

uses
    Main;

var
    ShwMemForm: TShwMemForm;

(*
    =================================================================
    ֐
    =================================================================
*)
procedure   OpenShwMemForm();
var
    AppName: string;
begin
    MainForm.MenuDbgMem.Enabled := false;
    ShwMemForm := TShwMemForm.Create(Application);
    AppName := ChangeFileExt(ExtractFileName(ParamStr(0)), '');
    ShwMemForm.Caption := AppName + ' - ' + ShwMemForm.Caption;
    ShwMemForm.Show();
end;

(*
    =================================================================
    ESCI
    =================================================================
*)
procedure TShwMemForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if (Key = VK_ESCAPE) then Self.Close;
end;

(*
    =================================================================
    OnClose
    =================================================================
*)
procedure TShwMemForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    Action := caFree;
    MainForm.MenuDbgMem.Enabled := true;
end;

(*
    =================================================================
    Subject: [Delphi:56760] Iz񂪊JȂ
    http://www.chami.com/tips/delphi/122496D.html
    =================================================================
*)
procedure TShwMemForm.Timer1Timer(Sender: TObject);
const
    MEGA = 1024 * 1024;
var
    MemoryStatus:TMemoryStatus;
    MemCount,MemSize: integer;
begin
    MemCount := AllocMemCount;
    MemSize  := AllocMemSize;
    MemoryStatus.dwLength:= SizeOf(MemoryStatus);
    GlobalMemoryStatus(MemoryStatus);
    ListBox1.Clear;
    with MemoryStatus, ListBox1.Items do
    begin
        Add(Format('App.ExeName     :%s'      , [ParamStr(0)]));
        Add(Format('App.Handle      :%d'      , [Application.Handle]));
        Add(StringOfChar('-', 50));
        Add(Format('AllocMemCount   :%d'      , [MemCount]));
        Add(Format('AllocMemSize    :%d'      , [MemSize]));
        Add(Format('dwMemoryLoad    :%d[%%]'  , [dwMemoryLoad]));
        Add(Format('dwTotalPhys     :%.2f[MB]', [dwTotalPhys / MEGA]));
        Add(Format('dwAvailPhys     :%.2f[MB]', [dwAvailPhys / MEGA]));
        Add(Format('dwTotalPageFile :%.2f[MB]', [dwTotalPageFile / MEGA]));
        Add(Format('dwAvailPageFile :%.2f[MB]', [dwAvailPageFile / MEGA]));
        Add(Format('dwTotalVirtual  :%.2f[MB]', [dwTotalVirtual / MEGA]));
        Add(Format('dwAvailVirtual  :%.2f[MB]', [dwAvailVirtual / MEGA]));
    end;
end;

end.

