unit ShwMsg;

interface

uses
  Windows, SysUtils, Forms, StdCtrls, Classes, Controls;

type
  TShwMsgForm = class(TForm)
    Memo1: TMemo;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
  private

  public
    procedure   MessageOut(AMsg: string);
  end;

procedure   OpenShwMsgForm();

implementation

{$R *.dfm}

uses
    iChii, Main;

var
    ShwMsgForm: TShwMsgForm;

(*
    =================================================================
    ֐
    =================================================================
*)
procedure   OpenShwMsgForm();
var
    AppName: string;
begin
    MainForm.MenuDbgMsg.Enabled := false;
    ShwMsgForm := TShwMsgForm.Create(Application);
    AppName := ChangeFileExt(ExtractFileName(ParamStr(0)), '');
    ShwMsgForm.Caption := AppName + ' - ' + ShwMsgForm.Caption;
    ShwMsgForm.Show();
end;

(*
    ===========================================================================
    bZ[W\
    ===========================================================================
*)
procedure TShwMsgForm.MessageOut(AMsg: string);
begin
    if (Memo1.Lines.Count > 200) then Memo1.Lines.Clear();
    Memo1.Lines.Add(AMsg);
end;

(*
    ===========================================================================
    OnShow
    ===========================================================================
*)
procedure TShwMsgForm.FormShow(Sender: TObject);
begin
    iChii.MSG_OUT_LVL_1 := MessageOut;
    iChii.MSG_OUT_LVL_2 := MessageOut;
end;

(*
    ===========================================================================
    OnClose
    ===========================================================================
*)
procedure TShwMsgForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    iChii.MSG_OUT_LVL_1 := nil;
    iChii.MSG_OUT_LVL_2 := nil;
    Action := caFree;
    MainForm.MenuDbgMsg.Enabled := true;
end;

(*
    =================================================================
    ESCI
    =================================================================
*)
procedure TShwMsgForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
    if (Key = VK_ESCAPE) then Self.Close;
end;

end.

